
#ifndef __MML_H__
#define __MML_H__
#ifdef __cplusplus
extern "C" {
#endif

//---------------------------------------------------------------------------
#define TEMPO_MAGIC		(60 * 60 * 4)

//MIDIKƎ̕ϊiS=V[vj
#define FLEQ_REST		0
#define FLEQ_C3			44
#define FLEQ_CS3		156
#define FLEQ_D3			262
#define FLEQ_DS3		363
#define FLEQ_E3			457
#define FLEQ_F3			547
#define FLEQ_FS3		631
#define FLEQ_G3			710
#define FLEQ_GS3		786
#define FLEQ_A3			854
#define FLEQ_AS3		923
#define FLEQ_B3			986
#define FLEQ_C4			1046
#define FLEQ_CS4		1102
#define FLEQ_D4			1155
#define FLEQ_DS4		1205
#define FLEQ_E4			1253
#define FLEQ_F4			1297
#define FLEQ_FS4		1339
#define FLEQ_G4			1379
#define FLEQ_GS4		1417
#define FLEQ_A4			1452
#define FLEQ_AS4		1486
#define FLEQ_B4			1517
#define FLEQ_C5			1546
#define FLEQ_CS5		1575
#define FLEQ_D5			1602
#define FLEQ_DS5		1627
#define FLEQ_E5			1650
#define FLEQ_F5			1673
#define FLEQ_FS5		1694
#define FLEQ_G5			1714
#define FLEQ_GS5		1732
#define FLEQ_A5			1750
#define FLEQ_AS5		1767
#define FLEQ_B5			1783
#define FLEQ_C6			1798
#define FLEQ_CS6		1812
#define FLEQ_D6			1825
#define FLEQ_DS6		1837
#define FLEQ_E6			1849
#define FLEQ_F6			1860
#define FLEQ_FS6		1871
#define FLEQ_G6			1881
#define FLEQ_GS6		1890
#define FLEQ_A6			1899
#define FLEQ_AS6		1907
#define FLEQ_B6			1915
#define FLEQ_C7			1923
#define FLEQ_CS7		1930
#define FLEQ_D7			1936
#define FLEQ_DS7		1943
#define FLEQ_E7			1949
#define FLEQ_F7			1954
#define FLEQ_FS7		1959
#define FLEQ_G7			1964
#define FLEQ_GS7		1969
#define FLEQ_A7			1974
#define FLEQ_AS7		1978
#define FLEQ_B7			1982
#define FLEQ_C8			1985
#define FLEQ_CS8		1988
#define FLEQ_D8			1992
#define FLEQ_DS8		1995
#define FLEQ_E8			1998
#define FLEQ_F8			2001
#define FLEQ_FS8		2004
#define FLEQ_G8			2006
#define FLEQ_GS8		2009
#define FLEQ_A8			2011
#define FLEQ_AS8		2013
#define FLEQ_B8			2015
#define FLEQ_ERR		9000
#define FLEQ_CTL		9001
#define FLEQ_END		9002


enum {
	TOKEN_C             = 1,
	TOKEN_CS,
	TOKEN_D,
	TOKEN_DS,
	TOKEN_E,
	TOKEN_F,
	TOKEN_FS,
	TOKEN_G,
	TOKEN_GS,
	TOKEN_A,
	TOKEN_AS,
	TOKEN_B,
	TOKEN_BS,        // = 13

	TOKEN_REST          = 50,
	TOKEN_OCTAVE,
	TOKEN_OCTAVE_UP,
	TOKEN_OCTAVE_DOWN,
	TOKEN_RELATIVE_X,
	TOKEN_LEN,
	TOKEN_PERIOD,
	TOKEN_TEMPO,
	TOKEN_SHARP,
	TOKEN_FLAT,
	TOKEN_VOLUME,
	TOKEN_TONE,
	TOKEN_ENVELOP_STEP,
	TOKEN_SWEEP,
	TOKEN_CANMA,
	TOKEN_END,
	TOKEN_ERR,
};


//---------------------------------------------------------------------------

typedef struct {
	u8*  pStr;			//MMLf[^
	u8*  pCur;			//Ăꏊ
	u8*  pPrev;			//PȌĂꏊ
	u16  tempo;			//ȑŜ̃e|il: T120j
	u16  len;			//̒iL1: S  L64: 64j
	u16  lenOnce;		//̒iʎwpj
	u16  lenCtdn;		//̃JEg_Ep
	s16  octave;		//IN^[uiO3-O8j
	u16  fleq;			//gi0: xj
	s16  volume;		//ʁi0-15Al: 7j
	s16  tone;			//Fi0- 3Al: 3j
	bool isRelativeX;	//'<'1IN^[u UP [h
	bool isRepeat;		//s[g̗L
	bool isPlay;		//Đ̗L
	bool isErr;			//G[L
	s16  envelopStep;	//̌i0-7Al: 7A傫قǌɎԂB0͌Ȃj
	bool sweepInc;		//XEB[v̑il: FALSEAFALSEȂdecATRUEȂINCj
	s16  sweepShift;	//XEB[v̗ʁi0-7Al: 0j
	s16  sweepTime;		//XEB[v̎ԁi0-7Al 0j
} ST_MML_STATUS;


typedef struct {
	bool isIRQ;
	ST_MML_STATUS ch1;
	ST_MML_STATUS ch2;
	ST_MML_STATUS ch4;
} ST_MML;


//---------------------------------------------------------------------------
IWRAM_CODE void MmlInit();
IWRAM_CODE void MmlInitSound();
IWRAM_CODE void MmlInitStatus(ST_MML_STATUS* p, u8 ch);

IWRAM_CODE void MmlHandler();
IWRAM_CODE void MmlHandlerSub(ST_MML_STATUS* p, u8 ch);

IWRAM_CODE void MmlPlayCh1();
IWRAM_CODE void MmlPlayCh2();
IWRAM_CODE void MmlPlayCh4();

IWRAM_CODE u8   MmlGetNextDat(ST_MML_STATUS* p);
IWRAM_CODE u8   MmlGetToken(u8 dat);
IWRAM_CODE u16  MmlGetFleq(ST_MML_STATUS* p);
IWRAM_CODE s16  MmlGetLenCtdn(ST_MML_STATUS* p);

IWRAM_CODE void MmlSetStr(u8 ch, char* pStr);
IWRAM_CODE void MmlSetPrevCur(ST_MML_STATUS* p);

IWRAM_CODE bool MmlIsOctave(s16 octave);
IWRAM_CODE bool MmlIsTone(s16 tone);
IWRAM_CODE bool MmlIsEnvelopStep(s16 envelopStep);
IWRAM_CODE bool MmlIsSweepTime(s16 num);
IWRAM_CODE bool MmlIsSweepShift(s16 num);
IWRAM_CODE bool MmlIsLen(s16 num);
IWRAM_CODE bool MmlIsVolume(s16 num);
IWRAM_CODE bool MmlIsTempo(s16 num);
IWRAM_CODE bool MmlIsNumber(u8 chr);
IWRAM_CODE bool MmlIsPlay();

IWRAM_CODE void MmlPlay();
IWRAM_CODE void MmlPlayRepeat();
IWRAM_CODE void MmlStop();

IWRAM_CODE void MmlDownOctave(ST_MML_STATUS* p);
IWRAM_CODE void MmlUpOctave(ST_MML_STATUS* p);


#ifdef __cplusplus
}
#endif
#endif


/*
-------------------------------------------------------------------------------
TEhCu  2004/9/16 Shinya Sato

g

1.܂͂߂ InitMusic() ĂяoďB
2.uh~xh~x݁vtꍇɂ́A
	Music1("CDERCDER");
	ƂB
	ȂAs[gĂقƂɂ Music1Repeat("CDERCDR"); ƂB
3. y~߂Ƃɂ Music1Stop();

Music1 ̂قɁAMusic2APerucussionlɂĎgB


ȂA匳̊֐́@http://f1.aaacafe.ne.jp/~progrm/gba/ 𗬗pĂ܂B


̗́Ả̗̂֏ƃp[JbV̑gݍ킹łB


int main(){
	
	// TEh iKKvj
	InitMusic();

	Music2("T220O5L4 CDEFEDCR EFGAGFER CRCRCRCR L8CCDDEEFF L4EDCR RRRRRRRR");
	Music1("T220O4L4 RRRRRRRR CDEFEDCR EFGAGFER CRCRCRCR L8CCDDEEFF L4EDCR");
	Percussion("T220L4 RBRBRBRB RBRBRBRB8B8 RBRBRBRB RBRBRBRB8B8 RB8B8RBRBBC");

	while(1){
        WaitForVsync();

	}

}


ȂAĐǂ͎̊֐Ŕł
iĐȂ1AȊO0ԂĂjF

---------------------------------------------------------------------------------

Ȃ̃e|
Tn : n  1--255


̒ L
L1@FS
L2@FQ
L3@FRAQiR̒Sj
L4@FS
L6@FRASiR̒Qj
L8@FW
L12@FRAWiR̒Sj
L16@F16
L24@FRA16iR̒Wj
L32@F32
L48@FRA32iR̒16j
L64@F64


K
K O Ŏw肷B
O3 -- O8 g
> 1IN^[uオA< 1IN^[u



CDEFGAB Rixj
V[v C# C+
tbg C-


̕\L
Eɑĉ킷t邱ƂłB
FC4D4E4 = L4CDE
EKɑăsIhgĉ\ƂłB
FC4.@ =  4+W
FC4..  =  4+W+16
ȂAsIh͂Q܂ŏd˂Ďw肷邱ƂłB


{[
V0 -- V15 ܂
ij--ij


F
@0 -- @3
SނIׂ


̌
Q1--S7,Q0
ij--ixj,iȂj


XEB[viMUSIC1 ̂݁j
Sn,m
n  Ԃ 0--7,0 ȗ 0
        iZj--ij
m ͕ὠx 1--7,0
        i傫j--ij
Ȃ }CiXtƉɕω



̑
Xy[XL͖B
ȋL͋xƂĈB


*/
