
#ifndef __SCREEN_H__
#define __SCREEN_H__
#ifdef __cplusplus
extern "C" {
#endif


//---------------------------------------------------------------------------
#define CURSOR_SPRITE_NO				514


//---------------------------------------------------------------------------
typedef struct {
	u16 x;
	u16 y;
	u16 buf[SCREEN_CX][SCREEN_CY] ALIGN(4);
} ST_SCREEN_IMG;


typedef struct {
	u16 x;
	u16 y;
	u16 sprNo;
	u16 tileNo;
	u8  blinkFlag;											//_ŗp̃tO
} ST_CURSOR;

//---------------------------------------------------------------------------
EWRAM_CODE void ScreenImgInit();
EWRAM_CODE void ScreenImgLoad(u16* pData);
EWRAM_CODE void ScreenImgClear();
EWRAM_CODE void ScreenImgUpdate();

EWRAM_CODE void ScreenImgFadeIn(u16 mode, u16 min, u16 max, u16 wait);
EWRAM_CODE void ScreenImgFadeOut(u16 wait);

EWRAM_CODE void ScreenImgDrawStr(u8* str);
EWRAM_CODE void ScreenImgDrawChr(u16 x, u16 y, u8 chr);
EWRAM_CODE void ScreenImgLineFeed();


//----
EWRAM_CODE void ScreenSprInit();
EWRAM_CODE void ScreenSprUpdate();

EWRAM_CODE void ScreenCurInit();
EWRAM_CODE void ScreenCurMove(u16 x, u16 y);

#ifdef __cplusplus
}
#endif
#endif
